#include <mega168.h>
#include <spi.h> 
#include <delay.h>
#include <i2c.h>
#include <ds1307.h>
 
#define SS PORTB.2
#define Sout PORTB.0

typedef unsigned char byte; 
typedef unsigned long ulong; 
 
byte led_table[10]={0b00000011,0b10011111,0b00100101,0b00001101,0b10011001,0b01001001,0b01000001,0b00011111,0b00000001,0b00001001}; 
unsigned char hour;
unsigned char min;
unsigned char sec;
//----------------------------------------------------//
void GetTime (void);
//----------------------------------------------------//
char Hours = 0x00;
char DesHours =0x00;
char Minutes = 0x00;
char DesMinutes =0x00;

void main(void) { 
PORTB=0; 
DDRB=0x2C; //   SPI
ACSR=0x80; //  
// SPI 
//   LSB-MSB, ..     
SPCR=0x70; 
SPSR=0;  

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=(0<<OCIE0B) | (0<<OCIE0A) | (1<<TOIE0);

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
// Mode: Normal top=0xFF
// OC0A output: Disconnected
// OC0B output: Disconnected
// Timer Period: 0,256 ms
TCCR0A=(0<<COM0A1) | (0<<COM0A0) | (0<<COM0B1) | (0<<COM0B0) | (0<<WGM01) | (0<<WGM00);
TCCR0B=(0<<WGM02) | (0<<CS02) | (1<<CS01) | (0<<CS00);
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;
#asm("sei");
i2c_init();
rtc_init(0,0,0);
rtc_set_time(12,0,0);

while (1) {
GetTime ();
    }
} 

//      DS1307
void GetTime (void){
rtc_get_time(&hour, &min, &sec);
DesHours = led_table[hour/10];
Hours = (led_table[hour%10]^0x01);
DesMinutes = led_table[min/10];
Minutes = led_table[min%10];
}


interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Place your code here
TIFR0 &= ~(1 << TOV0); // reset interrupt flag
SS=0;
spi(0x08);
spi(DesHours);
SS=1;
delay_us(100);
SS=0;
spi(0x04);
spi(Hours);
SS=1;
delay_us(100);
SS=0;
spi(0x02);
spi(DesMinutes);
SS=1;
delay_us(100);
SS=0;
spi(0x01);
spi(Minutes);
SS=1;
delay_us(100);
SS=0;
}