
#pragma used+
sfrb PINB=3;
sfrb DDRB=4;
sfrb PORTB=5;
sfrb PINC=6;
sfrb DDRC=7;
sfrb PORTC=8;
sfrb PIND=9;
sfrb DDRD=0xa;
sfrb PORTD=0xb;
sfrb TIFR0=0x15;
sfrb TIFR1=0x16;
sfrb TIFR2=0x17;
sfrb PCIFR=0x1b;
sfrb EIFR=0x1c;
sfrb EIMSK=0x1d;
sfrb GPIOR0=0x1e;
sfrb EECR=0x1f;
sfrb EEDR=0x20;
sfrb EEARL=0x21;
sfrb EEARH=0x22;
sfrw EEAR=0x21;   
sfrb GTCCR=0x23;
sfrb TCCR0A=0x24;
sfrb TCCR0B=0x25;
sfrb TCNT0=0x26;
sfrb OCR0A=0x27;
sfrb OCR0B=0x28;
sfrb GPIOR1=0x2a;
sfrb GPIOR2=0x2b;
sfrb SPCR=0x2c;
sfrb SPSR=0x2d;
sfrb SPDR=0x2e;
sfrb ACSR=0x30;
sfrb SMCR=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb SPMCSR=0x37;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.SET power_ctrl_reg=smcr
	#endif
#endasm

#pragma used+
unsigned char spi(unsigned char data);
#pragma used-

#pragma library spi.lib

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

#pragma used+
void i2c_init(void);
unsigned char i2c_start(void);
void i2c_stop(void);
unsigned char i2c_read(unsigned char ack);
unsigned char i2c_write(unsigned char data);
#pragma used-

#pragma used+

unsigned char rtc_read(unsigned char address);
void rtc_write(unsigned char address,unsigned char data);
void rtc_init(unsigned char rs,unsigned char sqwe,unsigned char out);
void rtc_get_time(unsigned char *hour,unsigned char *min,unsigned char *sec);
void rtc_set_time(unsigned char hour,unsigned char min,unsigned char sec);
void rtc_get_date(unsigned char *week_day, unsigned char *day,unsigned char *month,unsigned char *year);
void rtc_set_date(unsigned char week_day, unsigned char day,unsigned char month,unsigned char year);

#pragma used-

#pragma library ds1307.lib

typedef unsigned char byte; 
typedef unsigned long ulong; 

byte led_table[10]={0b00000011,0b10011111,0b00100101,0b00001101,0b10011001,0b01001001,0b01000001,0b00011111,0b00000001,0b00001001}; 
unsigned char hour;
unsigned char min;
unsigned char sec;

void GetTime (void);

char Hours = 0x00;
char DesHours =0x00;
char Minutes = 0x00;
char DesMinutes =0x00;

void main(void) { 
PORTB=0; 
DDRB=0x2C; 
ACSR=0x80; 

SPCR=0x70; 
SPSR=0;  

(*(unsigned char *) 0x6e)=(0<<2       ) | (0<<1       ) | (1<<0       );

TCCR0A=(0<<7       ) | (0<<6       ) | (0<<5       ) | (0<<4       ) | (0<<1       ) | (0<<0       );
TCCR0B=(0<<3       ) | (0<<2       ) | (1<<1       ) | (0<<0       );
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;
#asm("sei");
i2c_init();
rtc_init(0,0,0);
rtc_set_time(12,0,0);

while (1) {
GetTime ();
}
} 

void GetTime (void){
rtc_get_time(&hour, &min, &sec);
DesHours = led_table[hour/10];
Hours = (led_table[hour%10]^0x01);
DesMinutes = led_table[min/10];
Minutes = led_table[min%10];
}

interrupt [17] void timer0_ovf_isr(void)
{

TIFR0 &= ~(1 << 0       ); 
PORTB.2=0;
spi(0x08);
spi(DesHours);
PORTB.2=1;
delay_us(100);
PORTB.2=0;
spi(0x04);
spi(Hours);
PORTB.2=1;
delay_us(100);
PORTB.2=0;
spi(0x02);
spi(DesMinutes);
PORTB.2=1;
delay_us(100);
PORTB.2=0;
spi(0x01);
spi(Minutes);
PORTB.2=1;
delay_us(100);
PORTB.2=0;
}
